#Functions for Sander data
#
#standardizing coefficients
std.coef <- function (mod,option=1){
  if(option==1){
#    sy <- mean(response(mod))*(1-mean(response(mod)))/length(mod)
    sy <- sd(response(mod))
    sx <- sd(model.matrix(mod)[,-1])
    b <- coef(mod)[-1]
    b*sx/sy
  } else if(option==2){
    sx <- sd(model.matrix(mod)[,-1])
    b <- coef(mod)[-1]
    b*sx
  } else if(option==3){
    sy <- sd(response(mod))
    b <- coef(mod)[-1]
    b/sy
  } else if(option==4){
    sx <- sd(model.matrix(mod)[,-1])
    sy <- pi/sqrt(3)
    b <- coef(mod)[-1]
    b*sx/sy
  }
} 

#calculating standard errors by simulating from asymptotic posterior
sim.logit <- function(logitm){
  dta <- model.frame(logitm)
  cov <- summary(logitm)$cov.scaled
  coef <- logitm$coef
  library(mvtnorm)
  sims <- 1000
  simco <- rmvnorm(sims,coef,cov)
  steps <- rep(0,nrow(dta))
  diff3 <- matrix(0,length(steps),sims)
  ate <- matrix(0,nrow(dta),sims)
  XX <- model.matrix(logitm)
  for (i in 1:length(steps)){
    X <- XX[i,]
    X[2] <- 0
    p0 <- 1/(1+exp(-(simco%*%X)))
    X[2] <- 1
    p1 <- 1/(1+exp(-(simco%*%X)))
    p <- p1-p0
    diff3[i,] <- p
  }
  diff <- apply(diff3,2,mean)
  ate <- mean(diff)
  se <- sd(diff)
  ci <- quantile(diff,probs=c(0.025,0.5,0.975))
  list(ate = ate, se = se, ci = ci, n = nrow(XX))
}
